> For the complete documentation index, see [llms.txt](https://docs.auterion.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.auterion.com/app-development/auterion-sdk/peripheral-actuator-control-api.md).

# Peripheral Actuator Control API

{% hint style="info" %}
Related C++ Header in the Auterion SDK:`<auterion_sdk/control/common/peripheral_actuator_controls.hpp>`
{% endhint %}

Auterion SDK provides an interface to control [independent/generic actuators](https://docs.px4.io/main/en/payloads/#generic-actuator-control-in-missions) of the vehicle, that is, actuators which do not control the vehicle's motion or hardware that is not directly integrated with PX4, such as a payload servo. The control interface allows to set the value of up to 6 independent actuators, provided first that the [outputs are configured as Actuator Set x](https://docs.px4.io/main/en/payloads/#generic-actuator-control-with-mavlink).

## Set peripheral actuator values

Instantiate an `auterion::PeripheralActuatorControls` object by passing your `auterion::SDK` instance:

```cpp
auterion::PeripheralActuatorControls peripheral_actuator_controls(sdk);
```

Set your configured actuators to their desired state (in range `[-1, 1]`) using the `set(...)` method:

```cpp
// Set values for actuators 0-2, ignore actuators 3-5
Eigen::Matrix<float, 6, 1> params{-1.F, -.2F, .5F, NAN, NAN, NAN};
peripheral_actuator_controls.set(params);
```

Alternatively, `set(...)` is overloaded to set the value of a specific actuator:

```cpp
float param_value = 0.1F;  // range [-1, 1]
unsigned int actuator_index = 2;    // range [0, numActuators), numActuators = 6
peripheral_actuator_controls.set(param_value, actuator_index);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.auterion.com/app-development/auterion-sdk/peripheral-actuator-control-api.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
